var LOGFILE_NAME = "user-defined-actions-config.log";
var l = new Logger(LOGFILE_NAME);
var fLocalCopy = true;
// HLE ID >=1024

/**
*
*  UTF-8 data encode / decode
*  http://www.webtoolkit.info/
*
**/
 
var Utf8 = {
 
    // public method for url encoding
    encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";
 
        for (var n = 0; n < string.length; n++) {
 
            var c = string.charCodeAt(n);
 
            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
 
        }
 
        return utftext;
    },
 
    // public method for url decoding
    decode : function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;
 
        while ( i < utftext.length ) {
 
            c = utftext.charCodeAt(i);
 
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
 
        }
 
        return string;
    }
 
}


function storeSubParameter(path, value) {
    Property.setProperty('/usr/events/' + path, value);
    Property.setFlag('/usr/events/' + path, 'ARCHIVE', true);
    Property.setProperty('/usr/events/' + path, value);
    if (fLocalCopy) {
        Property.setProperty('/scripts/system-addon-user-defined-actions/' + path, value);
        Property.setFlag('/scripts/system-addon-user-defined-actions/' + path, 'ARCHIVE', true);
    }
}

function getNewIdValueFromBackup() {
    var idValue = new Date().getTime();
    var baseNode = Property.getNode('/scripts/system-addon-user-defined-actions');
    if (baseNode == null)
        return idValue;
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null)
            if (oChildNode.getChild('id').getValue() != null)
                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
    }
    return idValue;
}

function restoreFromBackup() {
    var baseNode = Property.getNode('/usr/');
    if (baseNode != null)
        Property.removeChild('events');
    var baseNodes = Property.getNode('/scripts/system-addon-user-defined-actions');
    if (baseNodes == null) {
        return;
    }

    var ffLocalCopy = fLocalCopy;
    fLocalCopy = false;
    for ( var iIndex = 0; iIndex < baseNodes.getChildren().length; iIndex++) {
        try {
            var oRootNode = baseNodes.getChildren()[iIndex];
            var esName = null;
            var idNode = oRootNode.getChild('id');
            if (idNode == null) {
                esName = getNewIdValueFromBackup();
            } else {
                esName = idNode.getValue();
            }
            if (oRootNode.getChild('name') != null) {
                storeSubParameter(esName + '/id', esName);
                l.logln('restore node number ' + iIndex + " " + oRootNode.getChild('name'));
                storeSubParameter(esName + '/name', oRootNode.getChild('name').getValue());
                storeSubParameter(esName + '/disabled', oRootNode.getChild('disabled').getValue());
                storeSubParameter(esName + '/lastSaved', oRootNode.getChild('lastSaved').getValue());
                for ( var jIndex = 0; jIndex < oRootNode.getChild('actions').getChildren().length; jIndex++) {
                    l.logln('restore subnode: ' + jIndex);
                    var oSubobject = oRootNode.getChild('actions').getChildren()[jIndex];
                    storeSubParameter(esName + '/actions/' + jIndex + '/type', oSubobject.getChild('type').getValue());
                    switch (oSubobject.getChild('type').getValue()) {
	                    case 'zone-scene':
	                        storeSubParameter(esName + '/actions/' + jIndex + '/zone', oSubobject.getChild('zone').getValue());
	                        storeSubParameter(esName + '/actions/' + jIndex + '/group', oSubobject.getChild('group').getValue());
	                        storeSubParameter(esName + '/actions/' + jIndex + '/scene', oSubobject.getChild('scene').getValue());
	                        storeSubParameter(esName + '/actions/' + jIndex + '/force', oSubobject.getChild('force').getValue());
	                    break;
	                    case 'undo-zone-scene':
	                        storeSubParameter(esName + '/actions/' + jIndex + '/zone', oSubobject.getChild('zone').getValue());
	                        storeSubParameter(esName + '/actions/' + jIndex + '/group', oSubobject.getChild('group').getValue());
	                        storeSubParameter(esName + '/actions/' + jIndex + '/scene', oSubobject.getChild('scene').getValue());
	                        storeSubParameter(esName + '/actions/' + jIndex + '/force', oSubobject.getChild('force').getValue());
	                    break;
                        case 'device-scene':
                            storeSubParameter(esName + '/actions/' + jIndex + '/dsid', oSubobject.getChild('dsid').getValue());
                            storeSubParameter(esName + '/actions/' + jIndex + '/scene', oSubobject.getChild('scene').getValue());
                            storeSubParameter(esName + '/actions/' + jIndex + '/force', oSubobject.getChild('force').getValue());
                        break;
                        case 'device-value':
                            storeSubParameter(esName + '/actions/' + jIndex + '/value', oSubobject.getChild('value').getValue());
                            storeSubParameter(esName + '/actions/' + jIndex + '/dsid', oSubobject.getChild('dsid').getValue());
                        break;
                        case 'device-blink':
                            storeSubParameter(esName + '/actions/' + jIndex + '/dsid', oSubobject.getChild('dsid').getValue());
                        break;
                        case 'zone-blink':
                            storeSubParameter(esName + '/actions/' + jIndex + '/zone', oSubobject.getChild('zone').getValue());
                            storeSubParameter(esName + '/actions/' + jIndex + '/group', oSubobject.getChild('group').getValue());
                        break;
                        case 'custom-event':
                            storeSubParameter(esName + '/actions/' + jIndex + '/event', oSubobject.getChild('event').getValue());
                        break;
                        case 'url':
                            storeSubParameter(esName + '/actions/' + jIndex + '/url', oSubobject.getChild('url').getValue());
                        break;                        
                        case 'change-state':
                        	storeSubParameter(esName + '/actions/' + jIndex + "/statename" , oSubobject.getChild('statename').getValue());
                            storeSubParameter(esName + '/actions/' + jIndex + "/state" , oSubobject.getChild('state').getValue());
                        break;
                        case 'change-addon-state':
                        	storeSubParameter(esName + '/actions/' + jIndex + "/statename" , oSubobject.getChild('statename').getValue());
                            storeSubParameter(esName + '/actions/' + jIndex + "/addon-id" , oSubobject.getChild('addon-id').getValue());
                            storeSubParameter(esName + '/actions/' + jIndex + "/state" , oSubobject.getChild('state').getValue());
                        break;                                                
                    }
                    if (oSubobject.getChild('delay') !=null)
                        storeSubParameter(esName + '/actions/' + jIndex + '/delay', oSubobject.getChild('delay').getValue());
                }
            }
        } catch (e) {
            l.logln("Fehler beim RestoreFROMBackup " + iIndex + " : " + e);
            fLocalCopy = ffLocalCopy;
        }
    }
    for ( var iIndex = 0; iIndex < baseNodes.getChildren().length; iIndex++) {
        try {
            var oRootNode = baseNodes.getChildren()[iIndex];
            l.logln("Backcheck " + oRootNode.name + " value = " + isNaN(parseInt(oRootNode.name,10)));
            if (isNaN(parseInt(oRootNode.name))) {
                l.logln("remove " + oRootNode.getPath());
                baseNodes.removeChild(oRootNode);
            }
        } catch (e) {
            l.logln("Fehler beim Backcheck " + iIndex + " : " + e);
        }
    }
    Property.store();
    fLocalCopy = ffLocalCopy;
}

function getNewIdValue() {
    var idValue = new Date().getTime();
    var baseNode = Property.getNode('/usr/events');
    if (baseNode == null)
        return idValue;
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null)
            if (oChildNode.getChild('id').getValue() != null)
                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
    }
    return idValue;
}

function storeValue(sParameterString) {
    try {
        var oParameterObject = JSON.parse(unescape(sParameterString));

        var idValue = null;
        if (oParameterObject.id != null)
            idValue = oParameterObject.id;
        else
            idValue = getNewIdValue();

        var esName = "" + idValue;

        var baseNode = Property.getNode('/scripts/system-addon-user-defined-actions');
        if (baseNode != null)
            baseNode.removeChild(esName);

        baseNode = Property.getNode('/usr/events');
        if (baseNode != null)
            baseNode.removeChild(esName);
        
        storeSubParameter(esName + '/name', Utf8.encode(unescape(oParameterObject.name)));
        storeSubParameter(esName + '/id', esName);
        storeSubParameter(esName + '/disabled', false);
        var iValue = new Date().getTime();
        storeSubParameter(esName + '/lastSaved', "" + iValue);

        for ( var iIndex = 0; iIndex < oParameterObject.actions.length; iIndex++) {
            var oSubobject = oParameterObject.actions[iIndex];
            storeSubParameter(esName + '/actions/' + iIndex + '/type', oSubobject.type);
            switch (oSubobject.type) {
                case 'zone-scene':
                    storeSubParameter(esName + '/actions/' + iIndex + '/zone', oSubobject.zone);
                    storeSubParameter(esName + '/actions/' + iIndex + '/group', oSubobject.group);
                    storeSubParameter(esName + '/actions/' + iIndex + '/scene', oSubobject.scene);
                    storeSubParameter(esName + '/actions/' + iIndex + '/force', oSubobject.force);
                break;
                case 'undo-zone-scene':
                    storeSubParameter(esName + '/actions/' + iIndex + '/zone', oSubobject.zone);
                    storeSubParameter(esName + '/actions/' + iIndex + '/group', oSubobject.group);
                    storeSubParameter(esName + '/actions/' + iIndex + '/scene', oSubobject.scene);
                    storeSubParameter(esName + '/actions/' + iIndex + '/force', oSubobject.force);
                break;
                case 'device-scene':
                    storeSubParameter(esName + '/actions/' + iIndex + '/dsid', oSubobject.dsid);
                    storeSubParameter(esName + '/actions/' + iIndex + '/scene', oSubobject.scene);
                    storeSubParameter(esName + '/actions/' + iIndex + '/force', oSubobject.force);
                break;
                case 'device-value':
                    storeSubParameter(esName + '/actions/' + iIndex + '/value', oSubobject.value);
                    storeSubParameter(esName + '/actions/' + iIndex + '/dsid', oSubobject.dsid);
                break;
                case 'device-blink':
                    storeSubParameter(esName + '/actions/' + iIndex + '/dsid', oSubobject.dsid);
                break;
                case 'zone-blink':
                    storeSubParameter(esName + '/actions/' + iIndex + '/zone', oSubobject.zone);
                    storeSubParameter(esName + '/actions/' + iIndex + '/group', oSubobject.group);
                break;
                case 'custom-event':
                    storeSubParameter(esName + '/actions/' + iIndex + '/event', oSubobject.event);
                break;
                case 'url':
                    storeSubParameter(esName + '/actions/' + iIndex + '/url', oSubobject.url);
                break;
                case 'change-state':
                	if (oSubobject.name!=null)
                		storeSubParameter(esName + '/actions/' + iIndex + "/statename" , oSubobject.name);
                	else
                		storeSubParameter(esName + '/actions/' + iIndex + "/statename" , oSubobject.statename);
                    storeSubParameter(esName + '/actions/' + iIndex + "/state" , oSubobject.state);
                break;
                case 'change-addon-state':
                	if (oSubobject.name!=null)
                		storeSubParameter(esName + '/actions/' + iIndex + "/statename" , oSubobject.name);
                	else
                		storeSubParameter(esName + '/actions/' + iIndex + "/statename" , oSubobject.statename);

                    storeSubParameter(esName + '/actions/' + iIndex + "/addon-id" , oSubobject.addonId);
                    storeSubParameter(esName + '/actions/' + iIndex + "/state" , oSubobject.state);
                break;
            }
            if (oSubobject.delay!=null) {
                storeSubParameter(esName + '/actions/' + iIndex + '/delay', oSubobject.delay);
            }
        }
        if (oSubobject.metaData!=null)
            storeSubParameter(esName + '/metaData', oSubobject.metaData);


        Property.store();
    } catch (e) {
        l.logln("Fehler beim Speichern: " + e);
        for ( var i in e) {
            l.logln(i + ': ' + e[i]);
        }

    }
}

l.logln("HLE-Config " + raisedEvent.name);
if (raisedEvent.name == 'system-addon-user-defined-actions-config') {
	Property.load();
    l.logln("HLE-Config param action " + raisedEvent.parameter.actions);
    if (raisedEvent.parameter.actions == 'save') {
        l.logln("HLE-Config param value " + raisedEvent.parameter.value);
        storeValue(raisedEvent.parameter.value);
        Property.store();
        var evt = new Event("system-addon-user-defined-actions-saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'enable') {
        l.logln("HLE-Config enable value " + raisedEvent.parameter.id);
        
        
        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
            var sanityCheck = Property.getNode('/scripts/system-addon-user-defined-actions/' + oIDObject[sKey]);
            if (sanityCheck != null) {                
                storeSubParameter(oIDObject[sKey] + '/conditions/enabled', true);
                var iValue = new Date().getTime();        
                storeSubParameter(oIDObject[sKey] + '/lastSaved', "" + iValue);
            }
        }
        
        Property.store();
        var evt = new Event("system-addon-user-defined-actions-saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'disable') {
        l.logln("HLE-Config disable value " + raisedEvent.parameter.id);

        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
            var sanityCheck = Property.getNode('/scripts/system-addon-user-defined-actions/' + oIDObject[sKey]);
            if (sanityCheck != null) {                
                storeSubParameter(oIDObject[sKey] + '/conditions/enabled', false);        
                var iValue = new Date().getTime();
                storeSubParameter(oIDObject[sKey] + '/lastSaved', "" + iValue);
            }        	
        }
        
        Property.store();
        var evt = new Event("system-addon-user-defined-actions-saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'delete') {
        l.logln("HLE-Config delete value " + raisedEvent.parameter.id);

        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
            var baseNode = Property.getNode('/usr/events');
            if (baseNode != null)
                baseNode.removeChild(oIDObject[sKey]);
            baseNode = Property.getNode('/scripts/system-addon-user-defined-actions');
            if (baseNode != null)
                baseNode.removeChild(oIDObject[sKey]);        	
        }

        Property.store();
        var evt = new Event("system-addon-user-defined-actions-saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'restore') {
        Property.load();
        restoreFromBackup();
        var evt = new Event("system-addon-user-defined-actions-saved", {});
        evt.raise();
    } 
} else if (raisedEvent.name == 'running') {
    Property.load();
    restoreFromBackup();
}
